//  Copyright 1999 McMillan Enterprises, Inc. -- www.mcmillan-inc.com
//  Copyright (C) 1999-2000 Jean-Claude Wippler.  All rights reserved.
//
//  Storage class header

#if !defined INCLUDE_PYSTORAGE_H
#define INCLUDE_PYSTORAGE_H

#include <mk4.h>
#include "PyHead.h"

extern PyTypeObject PyStoragetype;
class SiasStrategy;

#define PyStorage_Check(v) ((v)->ob_type==&PyStoragetype)

class PyStorage : public PyHead, public c4_Storage {
public:
	PyStorage() 
		: PyHead(PyStoragetype) { }
	PyStorage(c4_Strategy& strategy_, bool owned_ =false)
		: PyHead(PyStoragetype), c4_Storage(strategy_, owned_) { }
	PyStorage(const char *fnm, bool canModify)
		: PyHead(PyStoragetype), c4_Storage(fnm, canModify) { }
	PyStorage(const c4_Storage& storage_)
		: PyHead(PyStoragetype), c4_Storage(storage_) { }
//	PyStorage(const char *fnm, const char *descr) 
//		: PyHead(PyStoragetype), c4_Storage(fnm, descr) { }
	~PyStorage() { }
};

#endif
